;                                                                             MW7W 
;                                                                          MMMMMM 
;                                                                          MMMMMMX  .MMM:  
;                                                                         MMM  MMM r MMMMMMM: 
;                                                                          MMMMMM  MMMMMMMMM   
;                                                                          MMMMBMMMMM   ZMMMMM@ 
;   MMMMMW                             BMMMMMW;                     MMMM     MM  MMMM    M@MMMM  
;   MMM0MMMW                           MMMM8MMMM                                 :8MM:  MM@MMM0 
;   MMM  MMM MMM MMMM MMMMMM  MMMMMMM  @MMM iMMM  MMMMMMM  MMMMMMM  MMMM BMMMMMM  MMMMMMMMWM  
;   MMM  MMM MMM aMMM WMMMMM @MMM MMMM MMMM MMMZ MMMZ MMM  MMM @MMM MMMW MMM  MMM aMMMMMMMMMM 
;   MMMMMMMi MMM aMMM WMMM   MMMM0MMMM MMMMMMM   r  iiMMM: MMMM     MMM0 MMM         MMM  MW 
;   MMM      MMM aMMM WMMM   MMMM      MMMM 7MMM  MMM2MMMi   MMMMM  MMM8 MMM          M 
;   MMM      MMM XMMM WMMM   MMMM MMMM MMMM XMMM MMMa MMM: MS; BMMM MMMB MMM  MMM 
;   MMM      MMM WMMM MMMM   iMMM MMM0 MMMM7MMMM MMMM MMM; MMM BMMM MMMM MMMi MMM 
;   MMM      MMMMMMMM MMMM     MMMMM.  MMMMMMMM   MMM;MMM;  WMMMM8  MMMM  MMMMMX                                      

;                       _                   _               _
;                      | |                 | |             | |
;                      | |__   _   _       | |  __ _   ___ | | __
;                      | '_ \ | | | |  _   | | / _` | / __|| |/ /
;                      | |_) || |_| | | |__| || (_| || (__ |   <
;                      |_.__/  \__, |  \____/  \__,_| \___||_|\_\
;                               __/ |
;                              |___/

OpenConsole()

Procedure.f atan2(y.f,x.f)
;atan2 procedure by Paul Dixon
;http://www.powerbasic.com/support/forums/Forum4/HTML/009180.html
;adapted to PureBasic by Jack
! fld dword [esp]     ;load y
! fld dword [esp+4]   ;load x
! fpatan              ;get atan(y/x), put result in ST1. then pop stack to leave result in ST0
! ftst                ;test ST0 (that's the top of stack) against zero
! fstsw ax            ;put result of test into AX
! sahf                ;get the FPU flags into the CPU flags
! jae @f              ; if above or equal then skip the add 2*pi code
! fldpi               ;get pi
! fadd st1,st0        ;add pi to result
! faddp st1,st0       ;and again, for 2pi, then pop the now unneeded pi from st0
! @@:
EndProcedure

DefType.double x,y,z,u,v,w,z1,d1,d2,d3
DefType.l n,m,k,l,q

q.l=F64_Version()
F64_PI(x)
m=123456789
F64_Frac(x,y)
F64_Copy(z,x)
F64_Integer(z,z)
F64_Negate(x,v)
F64_Int(w,m)
F64_Sign(v,u)
n=F64_Sign(v)
k=F64_IsInt(x)
l=F64_IsInt(w)
PrintN("F64 Version "+Str(q)+"  ---- means 0.95")
PrintN("F64_PI(x)           ;x --> "+F64_Str(x, 15,#F64_Format_Auto))
PrintN("F64_Frac(x,y)       ;y --> "+F64_Str(y, 15,#F64_Format_Auto))
PrintN("F64_Integer(x,z)    ;z --> "+F64_Str(z, 15,#F64_Format_Auto))
PrintN("F64_Negate(x,v)     ;v --> "+F64_Str(v, 15,#F64_Format_Auto))
PrintN("n=F64_Sign(v)       ;n --> "+Str(n)+"       (v < 0)")
PrintN("n=F64_Sign(v,u)     ;u --> "+F64_Str(u, 15,#F64_Format_Auto))
PrintN("m=1234567           ;m --> "+Str(m))
Print("F64_Int(w,m)        ;w --> "+F64_Str(w, 15,#F64_Format_Auto))
PrintN("   the double var w = "+StrU(m,#Long))
PrintN("k=F64_IsInt(x)      ;k --> "+Str(k)+"       (no)")
PrintN("l=F64_IsInt(w)      ;l --> "+Str(l)+"       (yes)")
PrintN("")
PrintN("testing the F64_AtanQuad function:")
F64_Val(d1,"-.1")
F64_Val(d2,"-.1")
F64_AtanQuad(d1,d2,d3)
PrintN("F64_AtanQuad(-.1,-.1)    ; --> "+F64_Str(d3, 15,#F64_Format_Auto))
F64_Val(d1,"-.1")
F64_Val(d2,".1")
F64_AtanQuad(d1,d2,d3)
PrintN("F64_AtanQuad(-.1,.1)     ; --> "+F64_Str(d3, 15,#F64_Format_Auto))
F64_Val(d1,".1")
F64_Val(d2,".1")
F64_AtanQuad(d1,d2,d3)
PrintN("F64_AtanQuad(.1,.1)      ; --> "+F64_Str(d3, 15,#F64_Format_Auto))
F64_Val(d1,".1")
F64_Val(d2,"-.1")
F64_AtanQuad(d1,d2,d3)
PrintN("F64_AtanQuad(.1,-.1)     ; --> "+F64_Str(d3, 15,#F64_Format_Auto))
PrintN("")

Print("press return key to end ")
Input()
CloseConsole()

; ExecutableFormat=Windows
; CursorPosition=84
; FirstLine=51
; DisableDebugger
; EOF